diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/mid_set.c olsrd-current/src/mid_set.c
--- olsrd-0.5.0/src/mid_set.c	2007-02-10 20:27:32.000000000 +0100
+++ olsrd-current/src/mid_set.c	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: mid_set.c,v 1.17 2007/02/10 19:27:32 bernd67 Exp $
+ * $Id: mid_set.c,v 1.20 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -60,11 +60,11 @@
  */
 
 int
-olsr_init_mid_set()
+olsr_init_mid_set(void)
 {
   int index;
 
-  OLSR_PRINTF(5, "MID: init\n")
+  OLSR_PRINTF(5, "MID: init\n");
 
   /* Since the holdingtime is assumed to be rather large for 
    * MID entries, the timeoutfunction is only ran once every second
@@ -167,8 +167,8 @@
       /* Delete possible 2 hop neighbor */
       if((tmp_2_neighbor = olsr_lookup_two_hop_neighbor_table_mid(&tmp_adr->alias)) != NULL)
 	{
-	  OLSR_PRINTF(1, "Deleting 2 hop node from MID: %s to ", olsr_ip_to_string(&tmp_adr->alias))
-	  OLSR_PRINTF(1, "%s\n", olsr_ip_to_string(m_addr))
+	  OLSR_PRINTF(1, "Deleting 2 hop node from MID: %s to ", olsr_ip_to_string(&tmp_adr->alias));
+	  OLSR_PRINTF(1, "%s\n", olsr_ip_to_string(m_addr));
 
 	  olsr_delete_two_hop_neighbor_table(tmp_2_neighbor);
 
@@ -180,8 +180,8 @@
 	 && ((real_neigh = olsr_lookup_neighbor_table_alias(m_addr)) != NULL))
 
 	{
-	  OLSR_PRINTF(1, "[MID]Deleting bogus neighbor entry %s real ", olsr_ip_to_string(&tmp_adr->alias))
-	  OLSR_PRINTF(1, "%s\n", olsr_ip_to_string(m_addr))
+	  OLSR_PRINTF(1, "[MID]Deleting bogus neighbor entry %s real ", olsr_ip_to_string(&tmp_adr->alias));
+	  OLSR_PRINTF(1, "%s\n", olsr_ip_to_string(m_addr));
 
 	  replace_neighbor_link_set(tmp_neigh, real_neigh);
 
@@ -221,8 +221,8 @@
 
   adr = olsr_malloc(sizeof(struct mid_address), "Insert MID alias");
   
-  OLSR_PRINTF(1, "Inserting alias %s for ", olsr_ip_to_string(alias))
-  OLSR_PRINTF(1, "%s\n", olsr_ip_to_string(main_add))
+  OLSR_PRINTF(1, "Inserting alias %s for ", olsr_ip_to_string(alias));
+  OLSR_PRINTF(1, "%s\n", olsr_ip_to_string(main_add));
 
   COPY_IP(&adr->alias, alias);
   adr->next_alias = NULL;
@@ -302,7 +302,7 @@
   struct mid_entry *tmp_list;
   olsr_u32_t hash;
 
-  //OLSR_PRINTF(1, "MID: lookup entry...")
+  //OLSR_PRINTF(1, "MID: lookup entry...");
 
   hash = olsr_hashing(adr);
 
@@ -327,7 +327,7 @@
  *
  *@return a linked list of addresses structs
  */
-inline struct mid_address *
+struct mid_address *
 mid_lookup_aliases(union olsr_ip_addr *adr)
 {
   struct mid_entry *tmp = mid_lookup_entry_bymain(adr);
@@ -348,7 +348,7 @@
   struct mid_entry *tmp_list = mid_set;
   olsr_u32_t hash;
 
-  OLSR_PRINTF(3, "MID: update %s\n", olsr_ip_to_string(adr))
+  OLSR_PRINTF(3, "MID: update %s\n", olsr_ip_to_string(adr));
   hash = olsr_hashing(adr);
 
   /* Check all registered nodes...*/
@@ -422,8 +422,8 @@
       if (declared_aliases == 0)
         {
           /* Current alias not found in list of declared aliases: free current alias */
-          OLSR_PRINTF(1, "MID remove: (%s, ", olsr_ip_to_string(&entry->main_addr))
-          OLSR_PRINTF(1, "%s)\n", olsr_ip_to_string(&current_alias->alias))
+          OLSR_PRINTF(1, "MID remove: (%s, ", olsr_ip_to_string(&entry->main_addr));
+            OLSR_PRINTF(1, "%s)\n", olsr_ip_to_string(&current_alias->alias));
 
           /* Update linked list as seen by 'entry' */
           if (previous_alias != NULL)
@@ -461,7 +461,7 @@
  *@return nada
  */
 void
-olsr_time_out_mid_set(void *foo)
+olsr_time_out_mid_set(void *foo __attribute__((unused)))
 {
   int index;
 
@@ -478,8 +478,8 @@
 	      struct mid_entry *entry_to_delete = tmp_list;
 	      tmp_list = tmp_list->next;
 #ifdef DEBUG
-	      OLSR_PRINTF(1, "MID info for %s timed out.. deleting it\n", 
-			  olsr_ip_to_string(&entry_to_delete->main_addr))
+	      OLSR_PRINTF(1, "MID info for %s timed out.. deleting it\n",
+			  olsr_ip_to_string(&entry_to_delete->main_addr));
 #endif
 	      /*Delete it*/
 	      mid_delete_node(entry_to_delete);
@@ -527,30 +527,26 @@
  *For debuging purposes
  */
 void
-olsr_print_mid_set()
+olsr_print_mid_set(void)
 {
-
   int index;
 
-  OLSR_PRINTF(1, "mid set: %02d:%02d:%02d.%06lu\n",nowtm->tm_hour, nowtm->tm_min, nowtm->tm_sec, now.tv_usec)
+  OLSR_PRINTF(1, "mid set: %02d:%02d:%02d.%06lu\n",nowtm->tm_hour, nowtm->tm_min, nowtm->tm_sec, now.tv_usec);
 
   for(index=0;index<HASHSIZE;index++)
     {
       struct mid_entry *tmp_list = mid_set[index].next;
       /*Traverse MID list*/
-      for(tmp_list = mid_set[index].next;
-	  tmp_list != &mid_set[index];
-	  tmp_list = tmp_list->next)
+      for(tmp_list = mid_set[index].next; tmp_list != &mid_set[index]; tmp_list = tmp_list->next)
 	{
-	  struct mid_address *tmp_addr = tmp_list->aliases;
-
-	  OLSR_PRINTF(1, "%s: ", olsr_ip_to_string(&tmp_list->main_addr))
-	  while(tmp_addr)
+	  struct mid_address *tmp_addr;
+          
+	  OLSR_PRINTF(1, "%s: ", olsr_ip_to_string(&tmp_list->main_addr));
+          for(tmp_addr = tmp_list->aliases;tmp_addr;tmp_addr = tmp_addr->next_alias)
 	    {
-	      OLSR_PRINTF(1, " %s ", olsr_ip_to_string(&tmp_addr->alias))
-	      tmp_addr = tmp_addr->next_alias;
+	      OLSR_PRINTF(1, " %s ", olsr_ip_to_string(&tmp_addr->alias));
 	    }
-	  OLSR_PRINTF(1, "\n")	  
+	  OLSR_PRINTF(1, "\n");
 	}
     }
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/mpr.c olsrd-current/src/mpr.c
--- olsrd-0.5.0/src/mpr.c	2006-01-07 09:16:20.000000000 +0100
+++ olsrd-current/src/mpr.c	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: mpr.c,v 1.15 2006/01/07 08:16:20 kattemat Exp $
+ * $Id: mpr.c,v 1.17 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -121,7 +121,7 @@
 	  if((dup_neighbor != NULL) && (dup_neighbor->status != NOT_SYM))
 	    {
 	      
-	      //OLSR_PRINTF(1, "(1)Skipping 2h neighbor %s - already 1hop\n", olsr_ip_to_string(&two_hop_neighbor->neighbor_2_addr))
+	      //OLSR_PRINTF(1, "(1)Skipping 2h neighbor %s - already 1hop\n", olsr_ip_to_string(&two_hop_neighbor->neighbor_2_addr));
 
 	      continue;
 	    }
@@ -133,7 +133,7 @@
 		{
 		  two_hop_list_tmp = olsr_malloc(sizeof(struct neighbor_2_list_entry), "MPR two hop list");
 
-		  //OLSR_PRINTF(1, "ONE LINK ADDING %s\n", olsr_ip_to_string(&two_hop_neighbor->neighbor_2_addr))
+		  //OLSR_PRINTF(1, "ONE LINK ADDING %s\n", olsr_ip_to_string(&two_hop_neighbor->neighbor_2_addr));
 
 		  /* Only queue one way here */		  
 		  two_hop_list_tmp->neighbor_2 = two_hop_neighbor;
@@ -170,7 +170,7 @@
   
   count = *two_hop_covered_count;
 
-  OLSR_PRINTF(1, "Setting %s as MPR\n", olsr_ip_to_string(&one_hop_neighbor->neighbor_main_addr))
+  OLSR_PRINTF(1, "Setting %s as MPR\n", olsr_ip_to_string(&one_hop_neighbor->neighbor_main_addr));
 
   //printf("PRE COUNT: %d\n\n", count);
 
@@ -184,7 +184,7 @@
 
       if((dup_neighbor != NULL) && (dup_neighbor->status == SYM))
 	{
-	  //OLSR_PRINTF(7, "(2)Skipping 2h neighbor %s - already 1hop\n", olsr_ip_to_string(&second_hop_entries->neighbor_2->neighbor_2_addr))
+	  //OLSR_PRINTF(7, "(2)Skipping 2h neighbor %s - already 1hop\n", olsr_ip_to_string(&second_hop_entries->neighbor_2->neighbor_2_addr));
 	  continue;
 	}
 
@@ -197,7 +197,7 @@
 	  second_hop_entries->neighbor_2->mpr_covered_count++;
 	  the_one_hop_list = second_hop_entries->neighbor_2->neighbor_2_nblist.next;
 
-	  //OLSR_PRINTF(1, "[%s](%x) has coverage %d\n", olsr_ip_to_string(&second_hop_entries->neighbor_2->neighbor_2_addr), second_hop_entries->neighbor_2, second_hop_entries->neighbor_2->mpr_covered_count)
+	  //OLSR_PRINTF(1, "[%s](%x) has coverage %d\n", olsr_ip_to_string(&second_hop_entries->neighbor_2->neighbor_2_addr), second_hop_entries->neighbor_2, second_hop_entries->neighbor_2->mpr_covered_count);
 
 	  if(second_hop_entries->neighbor_2->mpr_covered_count >= olsr_cnf->mpr_coverage)
 	     count++;
@@ -276,18 +276,18 @@
  *Remove all MPR registrations
  */
 static void
-olsr_clear_mprs()
+olsr_clear_mprs(void)
 {
   olsr_u32_t index;
-  struct neighbor_entry   *a_neighbor;
-  struct neighbor_2_list_entry *two_hop_list;
   
   for (index=0;index<HASHSIZE;index++)
     {
+      struct neighbor_entry   *a_neighbor;
       for(a_neighbor = neighbortable[index].next;
 	  a_neighbor != &neighbortable[index];
 	  a_neighbor = a_neighbor->next)
 	{
+          struct neighbor_2_list_entry *two_hop_list;
 	  /* Clear MPR selection */
 	  if(a_neighbor->is_mpr)
 	    {
@@ -304,7 +304,6 @@
 	    }
 	}
     }
-
 }
 
 
@@ -314,16 +313,16 @@
  *@return 1 if changes occured 0 if not
  */
 static int
-olsr_check_mpr_changes()
+olsr_check_mpr_changes(void)
 {
   olsr_u32_t index;
-  struct neighbor_entry       *a_neighbor;
   int retval;
 
   retval = 0;
   
   for (index=0;index<HASHSIZE;index++)
     {
+      struct neighbor_entry *a_neighbor;
       for(a_neighbor = neighbortable[index].next;
 	  a_neighbor != &neighbortable[index];
 	  a_neighbor = a_neighbor->next)
@@ -346,13 +345,13 @@
  *on two hop neighbors
  */
 static void
-olsr_clear_two_hop_processed()
+olsr_clear_two_hop_processed(void)
 {
-  struct neighbor_2_entry  *neighbor_2;
   int index;
   
   for(index=0;index<HASHSIZE;index++)
     {
+      struct neighbor_2_entry  *neighbor_2;
       for(neighbor_2 = two_hop_neighbortable[index].next;
 	  neighbor_2 != &two_hop_neighbortable[index];
 	  neighbor_2 = neighbor_2->next)
@@ -369,32 +368,23 @@
  *This function calculates the number of two hop neighbors
  */
 static olsr_u16_t
-olsr_calculate_two_hop_neighbors()
+olsr_calculate_two_hop_neighbors(void)
 {
   olsr_u8_t                    index;
-  struct neighbor_entry        *a_neighbor, *dup_neighbor;
-  olsr_u16_t                   count, n_count, sum;
-  struct neighbor_2_list_entry *twohop_neighbors;
-  
-  //dup_neighbor = NULL;
-  
-  n_count = 0;
-  count = 0;
-  sum = 0;
-
+  olsr_u16_t                   sum = 0;
+  
   /* Clear 2 hop neighs */
   olsr_clear_two_hop_processed();
 
   for(index=0;index<HASHSIZE;index++)
     {
-      for(a_neighbor = neighbortable[index].next;
-	  a_neighbor != &neighbortable[index];
-	  a_neighbor = a_neighbor->next)
+      struct neighbor_entry *a_neighbor;
+      for(a_neighbor = neighbortable[index].next; a_neighbor != &neighbortable[index]; a_neighbor = a_neighbor->next)
 	{ 
-	  count = 0;
-	  n_count = 0;
-	  
-	  if(a_neighbor->status == NOT_SYM)
+          struct neighbor_2_list_entry *twohop_neighbors;
+          olsr_u16_t                   count = 0;
+          olsr_u16_t                   n_count = 0;
+          if(a_neighbor->status == NOT_SYM)
 	    {	    
 	      a_neighbor->neighbor_2_nocov = count;
 	      continue;
@@ -405,8 +395,7 @@
 	      twohop_neighbors = twohop_neighbors->next)
 	    {
 	      //printf("\tChecking %s....", olsr_ip_to_string(&twohop_neighbors->neighbor_2->neighbor_2_addr));
-	      
-	      dup_neighbor = olsr_lookup_neighbor_table(&twohop_neighbors->neighbor_2->neighbor_2_addr);
+              struct neighbor_entry *dup_neighbor = olsr_lookup_neighbor_table(&twohop_neighbors->neighbor_2->neighbor_2_addr);
 	      
 	      if((dup_neighbor == NULL) || (dup_neighbor->status != SYM))
 		{
@@ -425,7 +414,7 @@
 	}
     }
   
-  OLSR_PRINTF(3, "Two hop neighbors: %d\n", sum)
+  OLSR_PRINTF(3, "Two hop neighbors: %d\n", sum);
   return sum;
 }
 
@@ -436,19 +425,16 @@
  * Adds all nodes with willingness set to WILL_ALWAYS
  */
 static olsr_u16_t
-add_will_always_nodes()
+add_will_always_nodes(void)
 {
-
+  olsr_u16_t                   count = 0;
   olsr_u8_t                    index;
-  struct neighbor_entry        *a_neighbor;
-  olsr_u16_t                   count;
-
-  count = 0;
 
   //printf("\nAdding WILL ALWAYS nodes....\n");
 
   for(index=0;index<HASHSIZE;index++)
     {
+      struct neighbor_entry        *a_neighbor;
       for(a_neighbor = neighbortable[index].next;
 	  a_neighbor != &neighbortable[index];
 	  a_neighbor = a_neighbor->next)
@@ -458,12 +444,12 @@
 
 	  olsr_chosen_mpr(a_neighbor, &count); 
 
-	  OLSR_PRINTF(3, "Adding WILL_ALWAYS: %s\n", olsr_ip_to_string(&a_neighbor->neighbor_main_addr))
+	  OLSR_PRINTF(3, "Adding WILL_ALWAYS: %s\n", olsr_ip_to_string(&a_neighbor->neighbor_main_addr));
 
 	}
     }
   
-  //OLSR_PRINTF(1, "Count: %d\n", count)
+  //OLSR_PRINTF(1, "Count: %d\n", count);
   return count;
 }
 
@@ -472,22 +458,16 @@
  *@return nada
  */
 void
-olsr_calculate_mpr()     
-{
-  
-  olsr_u16_t                   two_hop_covered_count=0;
-  olsr_u16_t                   two_hop_count=0;  
-  struct neighbor_2_list_entry *two_hop_list=NULL;
-  struct neighbor_2_list_entry *tmp;
-  struct neighbor_entry        *mprs; 
+olsr_calculate_mpr(void)     
+{  
+  olsr_u16_t                   two_hop_covered_count;
+  olsr_u16_t                   two_hop_count;
   int i;
 
-  OLSR_PRINTF(3, "\n**RECALCULATING MPR**\n\n")
+  OLSR_PRINTF(3, "\n**RECALCULATING MPR**\n\n");
 
   olsr_clear_mprs();
-
   two_hop_count = olsr_calculate_two_hop_neighbors();
-
   two_hop_covered_count += add_will_always_nodes();
 
   /*
@@ -496,10 +476,12 @@
 
   for(i = WILL_ALWAYS - 1; i > WILL_NEVER; i--)
     {
-      two_hop_list = olsr_find_2_hop_neighbors_with_1_link(i);
+      struct neighbor_entry        *mprs; 
+      struct neighbor_2_list_entry *two_hop_list = olsr_find_2_hop_neighbors_with_1_link(i);
 
       while(two_hop_list != NULL)
 	{
+          struct neighbor_2_list_entry *tmp;
 	  //printf("CHOSEN FROM 1 LINK\n");
 	  if(!two_hop_list->neighbor_2->neighbor_2_nblist.next->neighbor->is_mpr)
 	    olsr_chosen_mpr(two_hop_list->neighbor_2->neighbor_2_nblist.next->neighbor, &two_hop_covered_count); 
@@ -540,7 +522,7 @@
 
   if(olsr_check_mpr_changes())
     {
-      OLSR_PRINTF(3, "CHANGES IN MPR SET\n")
+      OLSR_PRINTF(3, "CHANGES IN MPR SET\n");
       if(olsr_cnf->tc_redundancy > 0)
 	signal_link_changes(OLSR_TRUE);
     }
@@ -557,20 +539,18 @@
  *@return nada
  */
 static void
-olsr_optimize_mpr_set()
+olsr_optimize_mpr_set(void)
 {
-  int i, remove, index;
-  struct neighbor_2_list_entry *two_hop_list;
-  struct neighbor_entry *a_neighbor, *dup_neighbor;
+  int i, remove;
 
   //printf("\n**MPR OPTIMIZING**\n\n");
 
   for(i = WILL_NEVER + 1; i < WILL_ALWAYS; i++)
     {
-
+      int index;
       for(index=0;index<HASHSIZE;index++)
 	{
-
+          struct neighbor_entry *a_neighbor;
 	  for(a_neighbor = neighbortable[index].next;
 	      a_neighbor != &neighbortable[index];
 	      a_neighbor = a_neighbor->next)
@@ -581,6 +561,7 @@
 	      
 	      if(a_neighbor->is_mpr)
 		{
+                  struct neighbor_2_list_entry *two_hop_list;
 		  //printf("\tChecking %s\n", olsr_ip_to_string(&a_neighbor->neighbor_main_addr));
 		  remove = 1;
 
@@ -589,7 +570,7 @@
 		      two_hop_list = two_hop_list->next)
 		    {
 		      
-		      dup_neighbor = olsr_lookup_neighbor_table(&two_hop_list->neighbor_2->neighbor_2_addr);
+                      const struct neighbor_entry * const dup_neighbor = olsr_lookup_neighbor_table(&two_hop_list->neighbor_2->neighbor_2_addr);
 		      
 		      if((dup_neighbor != NULL) && (dup_neighbor->status != NOT_SYM))
 			continue;
@@ -602,46 +583,37 @@
 		    }
 		  if(remove)
 		    {
-		      OLSR_PRINTF(3, "MPR OPTIMIZE: removiong mpr %s\n\n", olsr_ip_to_string(&a_neighbor->neighbor_main_addr))
+		      OLSR_PRINTF(3, "MPR OPTIMIZE: removiong mpr %s\n\n", olsr_ip_to_string(&a_neighbor->neighbor_main_addr));
 		      a_neighbor->is_mpr = OLSR_FALSE;
 		    }
-
-
 		}
 	    }
-	  
 	}
-
-
     }
-
 }
 
 
 
 void
-olsr_print_mpr_set()
+olsr_print_mpr_set(void)
 {
-  int                   index;
-  struct neighbor_entry *a_neighbor;
+  int index;
 
-  OLSR_PRINTF(1, "MPR SET: ")
+  OLSR_PRINTF(1, "MPR SET: ");
 
   for(index=0;index<HASHSIZE;index++)
     {
+      struct neighbor_entry *a_neighbor;
       for(a_neighbor = neighbortable[index].next;
 	  a_neighbor != &neighbortable[index];
 	  a_neighbor = a_neighbor->next)
 	{ 
-	  
 	  /* 
 	   * Remove MPR settings
 	   */
 	  if(a_neighbor->is_mpr)
-	    OLSR_PRINTF(1, "[%s] ", olsr_ip_to_string(&a_neighbor->neighbor_main_addr))
+	    OLSR_PRINTF(1, "[%s] ", olsr_ip_to_string(&a_neighbor->neighbor_main_addr));
 	}
     }
-
-  OLSR_PRINTF(1, "\n")
-
+  OLSR_PRINTF(1, "\n");
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/mpr_selector_set.c olsrd-current/src/mpr_selector_set.c
--- olsrd-0.5.0/src/mpr_selector_set.c	2006-01-07 09:16:20.000000000 +0100
+++ olsrd-current/src/mpr_selector_set.c	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: mpr_selector_set.c,v 1.15 2006/01/07 08:16:20 kattemat Exp $
+ * $Id: mpr_selector_set.c,v 1.17 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 
@@ -55,9 +55,9 @@
  */
 
 int
-olsr_init_mprs_set()
+olsr_init_mprs_set(void)
 {
-  OLSR_PRINTF(5, "MPRS: Init\n")
+  OLSR_PRINTF(5, "MPRS: Init\n");
   /* Initial values */
   ansn = 0;
 
@@ -65,20 +65,19 @@
   
   mprs_list.next = &mprs_list;
   mprs_list.prev = &mprs_list;
-  
 
   return 1;
 }
 
 
 olsr_u16_t 
-get_local_ansn()
+get_local_ansn(void)
 {
   return ansn;
 }
 
 void
-increase_local_ansn()
+increase_local_ansn(void)
 {
   ansn++;
 }
@@ -88,7 +87,7 @@
  * neighbors. If the list is empty we are not MPR.
  */
 olsr_bool
-olsr_is_mpr()
+olsr_is_mpr(void)
 {
     return ((mprs_list.next == &mprs_list) ? OLSR_FALSE : OLSR_TRUE);
 }
@@ -106,7 +105,7 @@
 {
   struct mpr_selector *new_entry;
 
-  OLSR_PRINTF(1, "MPRS: adding %s\n", olsr_ip_to_string(addr))
+  OLSR_PRINTF(1, "MPRS: adding %s\n", olsr_ip_to_string(addr));
 
   new_entry = olsr_malloc(sizeof(struct mpr_selector), "Add MPR selector");
 
@@ -143,7 +142,7 @@
 
   if(addr == NULL)
     return NULL;
-  //OLSR_PRINTF(1, "MPRS: Lookup....")
+  //OLSR_PRINTF(1, "MPRS: Lookup....");
 
   mprs = mprs_list.next;
 
@@ -152,13 +151,13 @@
 
       if(COMP_IP(&mprs->MS_main_addr, addr))
 	{
-	  //OLSR_PRINTF(1, "MATCH\n")
+	  //OLSR_PRINTF(1, "MATCH\n");
 	  return mprs;
 	}
       mprs = mprs->next;
     }
   
-  //OLSR_PRINTF(1, "NO MACH\n")
+  //OLSR_PRINTF(1, "NO MACH\n");
   return NULL;
 }
 
@@ -178,7 +177,7 @@
   struct mpr_selector *mprs;
   int retval;
 
-  OLSR_PRINTF(5, "MPRS: Update %s\n", olsr_ip_to_string(addr))
+  OLSR_PRINTF(5, "MPRS: Update %s\n", olsr_ip_to_string(addr));
 
   retval = 0;
 
@@ -195,32 +194,25 @@
   return retval;
 }
 
-
-
-
-
 /**
  *Time out MPR selector entries
  *
  *@return nada
  */
 void
-olsr_time_out_mprs_set()
+olsr_time_out_mprs_set(void)
 {
-  struct mpr_selector *mprs;
-
-  mprs = mprs_list.next;
+  struct mpr_selector *mprs = mprs_list.next;
 
   while(mprs != &mprs_list)
     {
-
       if(TIMED_OUT(mprs->MS_time))
 	{
 	  /* Dequeue */
 	  struct mpr_selector *mprs_to_delete = mprs;
 	  mprs = mprs->next;
 
-	  OLSR_PRINTF(1, "MPRS: Timing out %s\n", olsr_ip_to_string(&mprs_to_delete->MS_main_addr))
+	  OLSR_PRINTF(1, "MPRS: Timing out %s\n", olsr_ip_to_string(&mprs_to_delete->MS_main_addr));
 
 	  DEQUEUE_ELEM(mprs_to_delete);
 
@@ -231,27 +223,20 @@
       else
 	mprs = mprs->next;
     }
-
 }
 
-
-
 /**
  *Print the current MPR selector set to STDOUT
  */
 void
-olsr_print_mprs_set()
+olsr_print_mprs_set(void)
 {
   struct mpr_selector *mprs;
+  OLSR_PRINTF(1, "MPR SELECTORS: ");
 
-
-  mprs = mprs_list.next;
-  OLSR_PRINTF(1, "MPR SELECTORS: ")
-
-  while(mprs != &mprs_list)
+    for(mprs = mprs_list.next; mprs != &mprs_list; mprs = mprs->next)
     {
-      OLSR_PRINTF(1, "%s ", olsr_ip_to_string(&mprs->MS_main_addr))
-      mprs = mprs->next;
+      OLSR_PRINTF(1, "%s ", olsr_ip_to_string(&mprs->MS_main_addr));
     }
-  OLSR_PRINTF(1, "\n")
+  OLSR_PRINTF(1, "\n");
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/neighbor_table.c olsrd-current/src/neighbor_table.c
--- olsrd-0.5.0/src/neighbor_table.c	2006-01-07 09:16:20.000000000 +0100
+++ olsrd-current/src/neighbor_table.c	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: neighbor_table.c,v 1.30 2006/01/07 08:16:20 kattemat Exp $
+ * $Id: neighbor_table.c,v 1.32 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 
@@ -56,12 +56,11 @@
 
 
 void
-olsr_init_neighbor_table()
+olsr_init_neighbor_table(void)
 {
   int i;
 
   olsr_register_timeout_function(&olsr_time_out_neighborhood_tables);
-
   for(i = 0; i < HASHSIZE; i++)
     {
       neighbortable[i].next = &neighbortable[i];
@@ -437,31 +436,21 @@
     }
 }
 
-
-
-
-
 void
-olsr_time_out_neighborhood_tables()
+olsr_time_out_neighborhood_tables(void)
 {
-  olsr_u8_t              index;
+  olsr_u8_t index;
   
   for(index=0;index<HASHSIZE;index++)
     {
-      struct neighbor_entry *entry = neighbortable[index].next;
-
-      while(entry != &neighbortable[index])
+      struct neighbor_entry *entry;
+      for(entry = neighbortable[index].next; entry != &neighbortable[index]; entry = entry->next)
 	{	  
 	  olsr_time_out_two_hop_neighbors(entry);
-	  entry = entry->next;
 	}
     }
 }
 
-
-
-
-
 /**
  *Prints the registered neighbors and two hop neighbors
  *to STDOUT.
@@ -469,7 +458,7 @@
  *@return nada
  */
 void
-olsr_print_neighbor_table()
+olsr_print_neighbor_table(void)
 {
   int i;
   char *fstr;
@@ -478,42 +467,37 @@
               nowtm->tm_hour,
               nowtm->tm_min,
               nowtm->tm_sec,
-              (int)now.tv_usec/10000)
+              (int)now.tv_usec/10000);
 
   if (olsr_cnf->ip_version == AF_INET)
-  {
-    OLSR_PRINTF(1, "IP address       LQ     NLQ    SYM   MPR   MPRS  will\n")
-    fstr = "%-15s  %5.3f  %5.3f  %s  %s  %s  %d\n";
-  }
-
+    {
+      OLSR_PRINTF(1, "IP address       LQ     NLQ    SYM   MPR   MPRS  will\n");
+      fstr = "%-15s  %5.3f  %5.3f  %s  %s  %s  %d\n";
+    }
   else
-  {
-    OLSR_PRINTF(1, "IP address                               LQ     NLQ    SYM   MPR   MPRS  will\n")
-    fstr = "%-39s  %5.3f  %5.3f  %s  %s  %s  %d\n";
-  }
+    {
+      OLSR_PRINTF(1, "IP address                               LQ     NLQ    SYM   MPR   MPRS  will\n");
+      fstr = "%-39s  %5.3f  %5.3f  %s  %s  %s  %d\n";
+    }
 
   for (i = 0; i < HASHSIZE; i++)
     {
       struct neighbor_entry *neigh;
-      for(neigh = neighbortable[i].next; neigh != &neighbortable[i];
-	  neigh = neigh->next)
+      for(neigh = neighbortable[i].next; neigh != &neighbortable[i]; neigh = neigh->next)
 	{
-	  struct link_entry *link =
-            get_best_link_to_neighbor(&neigh->neighbor_main_addr);
-	  double best_lq, inv_best_lq;
-
-	  if(!link) 
-	    continue;
-
-	  best_lq = link->neigh_link_quality;
-	  inv_best_lq = link->loss_link_quality;
-
-          OLSR_PRINTF(1, fstr, olsr_ip_to_string(&neigh->neighbor_main_addr),
-                      inv_best_lq, best_lq,
-                      (neigh->status == SYM) ? "YES " : "NO  ",
-                      neigh->is_mpr ? "YES " : "NO  ", 
-		      olsr_lookup_mprs_set(&neigh->neighbor_main_addr) == NULL ? "NO  " : "YES ",
-                      neigh->willingness)
+	  struct link_entry *link = get_best_link_to_neighbor(&neigh->neighbor_main_addr);
+	  if(link)
+            {
+              double best_lq = link->neigh_link_quality;
+              double inv_best_lq = link->loss_link_quality;
+
+              OLSR_PRINTF(1, fstr, olsr_ip_to_string(&neigh->neighbor_main_addr),
+                          inv_best_lq, best_lq,
+                          (neigh->status == SYM) ? "YES " : "NO  ",
+                          neigh->is_mpr ? "YES " : "NO  ", 
+                          olsr_lookup_mprs_set(&neigh->neighbor_main_addr) == NULL ? "NO  " : "YES ",
+                          neigh->willingness);
+            }
         }
     }
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/net_olsr.c olsrd-current/src/net_olsr.c
--- olsrd-0.5.0/src/net_olsr.c	2007-02-10 20:59:51.000000000 +0100
+++ olsrd-current/src/net_olsr.c	2007-05-14 00:23:55.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: net_olsr.c,v 1.19 2007/02/10 19:59:51 bernd67 Exp $
+ * $Id: net_olsr.c,v 1.23 2007/05/13 22:23:55 bernd67 Exp $
  */
 
 #include "net_olsr.h"
@@ -77,8 +77,6 @@
 
 static struct ptf *ptf_list;
 
-static char ipv6_buf[100]; /* for address coversion */
-
 static struct deny_address_entry *deny_entries;
 
 static const char * const deny_ipv4_defaults[] =
@@ -104,16 +102,15 @@
 void
 init_net(void)
 {
-  union olsr_ip_addr addr;
-  int i;
-
   /* Block invalid addresses */
   if(olsr_cnf->ip_version == AF_INET)
     {
+      union olsr_ip_addr addr;
+      int i;
       /* IPv4 */
       for(i = 0; deny_ipv4_defaults[i] != NULL; i++)
 	{
-	  if(inet_pton(olsr_cnf->ip_version, deny_ipv4_defaults[i], &addr) < 0)
+	  if(inet_pton(olsr_cnf->ip_version, deny_ipv4_defaults[i], &addr) <= 0)
 	    {
 	      fprintf(stderr, "Error converting fixed IP %s for deny rule!!\n",
 		      deny_ipv4_defaults[i]);
@@ -124,10 +121,12 @@
     }
   else 
     {
+      union olsr_ip_addr addr;
+      int i;
       /* IPv6 */
       for(i = 0; deny_ipv6_defaults[i] != NULL; i++)
 	{
-	  if(inet_pton(olsr_cnf->ip_version, deny_ipv6_defaults[i], &addr) < 0)
+	  if(inet_pton(olsr_cnf->ip_version, deny_ipv6_defaults[i], &addr) <= 0)
 	    {
 	      fprintf(stderr, "Error converting fixed IP %s for deny rule!!\n",
 		      deny_ipv6_defaults[i]);
@@ -250,7 +249,7 @@
  *  success
  */
 int
-net_outbuffer_push(struct interface *ifp, olsr_u8_t *data, olsr_u16_t size)
+net_outbuffer_push(struct interface *ifp, const void *data, const olsr_u16_t size)
 {
   if((ifp->netbuf.pending + size) > ifp->netbuf.maxsize)
     return 0;
@@ -274,7 +273,7 @@
  *  success
  */
 int
-net_outbuffer_push_reserved(struct interface *ifp, olsr_u8_t *data, olsr_u16_t size)
+net_outbuffer_push_reserved(struct interface *ifp, const void *data, const olsr_u16_t size)
 {
   if((ifp->netbuf.pending + size) > (ifp->netbuf.maxsize + ifp->netbuf.reserved))
     return 0;
@@ -294,7 +293,7 @@
  * @return the number of bytes available in the buffer or
  */
 int
-net_outbuffer_bytes_left(struct interface *ifp)
+net_outbuffer_bytes_left(const struct interface *ifp)
 {
   return ifp->netbuf.maxsize - ifp->netbuf.pending;
 }
@@ -417,11 +416,9 @@
   /*
    *Call possible packet transform functions registered by plugins  
    */
-  tmp_ptf_list = ptf_list;
-  while(tmp_ptf_list != NULL)
+  for (tmp_ptf_list = ptf_list; tmp_ptf_list != NULL; tmp_ptf_list = tmp_ptf_list->next)
     {
       tmp_ptf_list->function(ifp->netbuf.buff, &ifp->netbuf.pending);
-      tmp_ptf_list = tmp_ptf_list->next;
     }
 
   /*
@@ -461,7 +458,7 @@
 	{
 	  perror("sendto(v6)");
 	  olsr_syslog(OLSR_LOG_ERR, "OLSR: sendto IPv6 %m");
-	  fprintf(stderr, "Socket: %d interface: %d\n", ifp->olsr_socket, ifp->if_nr);
+	  fprintf(stderr, "Socket: %d interface: %d\n", ifp->olsr_socket, ifp->if_index);
 	  fprintf(stderr, "To: %s (size: %d)\n", ip6_to_string(&sin6->sin6_addr), (int)sizeof(*sin6));
 	  fprintf(stderr, "Outputsize: %d\n", ifp->netbuf.pending);
 	  retval = -1;
@@ -508,7 +505,7 @@
     }
 
 #ifdef DEBUG
-  OLSR_PRINTF(3, "Prefix %d = Netmask: %s\n", prefix, olsr_ip_to_string(adr))
+  OLSR_PRINTF(3, "Prefix %d = Netmask: %s\n", prefix, olsr_ip_to_string(adr));
 #endif
 
   return 1;
@@ -547,7 +544,7 @@
     }
 
 #ifdef DEBUG
-  OLSR_PRINTF(3, "Netmask: %s = Prefix %d\n", olsr_ip_to_string(adr), prefix)
+  OLSR_PRINTF(3, "Netmask: %s = Prefix %d\n", olsr_ip_to_string(adr), prefix);
 #endif
 
   return prefix;
@@ -585,19 +582,15 @@
  *@return a char pointer to the string containing the IP
  */
 
-char *
-ip_to_string(olsr_u32_t *address)
+const char *
+ip_to_string(const olsr_u32_t *address)
 {
-
   struct in_addr in;
   in.s_addr=*address;
   return(inet_ntoa(in));
   
 }
 
-
-
-
 /**
  *Converts the 32bit olsr_u32_t datatype to
  *a char array.
@@ -608,36 +601,36 @@
  *@return a char pointer to the string containing the IP
  */
 
-char *
-ip6_to_string(struct in6_addr *addr6)
+const char *
+ip6_to_string(const struct in6_addr *addr6)
 {
-  return (char *)inet_ntop(AF_INET6, addr6, ipv6_buf, sizeof(ipv6_buf));
+  static char ipv6_buf[INET6_ADDRSTRLEN]; /* for address coversion */
+  return inet_ntop(AF_INET6, addr6, ipv6_buf, sizeof(ipv6_buf));
 }
 
 
-char *
-olsr_ip_to_string(union olsr_ip_addr *addr)
+const char *
+olsr_ip_to_string(const union olsr_ip_addr *addr)
 {
   static int index = 0;
-  static char buff[4][100];
-  char *ret;
-  struct in_addr in;
+  static char buff[4][INET6_ADDRSTRLEN > INET_ADDRSTRLEN ? INET6_ADDRSTRLEN : INET_ADDRSTRLEN];
+  const char *ret;
   
   if(olsr_cnf->ip_version == AF_INET)
     {
-      in.s_addr=addr->v4;
-      ret = inet_ntoa(in);
+#if 0
+      struct in_addr in;
+      in.s_addr = addr->v4;
+      ret = inet_ntop(AF_INET, &in, buff[index], sizeof(buff[index]));
+#else
+      ret = inet_ntop(AF_INET, &addr->v6, buff[index], sizeof(buff[index]));
+#endif
     }
   else
     {
       /* IPv6 */
-      ret = (char *)inet_ntop(AF_INET6, &addr->v6, ipv6_buf, sizeof(ipv6_buf));
+      ret = inet_ntop(AF_INET6, &addr->v6, buff[index], sizeof(buff[index]));
     }
-
-  strncpy(buff[index], ret, 100);
-
-  ret = buff[index];
-
   index = (index + 1) & 3;
 
   return ret;
@@ -656,7 +649,7 @@
 
   deny_entries = new_entry;
 
-  OLSR_PRINTF(1, "Added %s to IP deny set\n", olsr_ip_to_string(&new_entry->addr))
+  OLSR_PRINTF(1, "Added %s to IP deny set\n", olsr_ip_to_string(&new_entry->addr));
   return;
 }
 
@@ -679,7 +672,7 @@
       if(COMP_IP(adr, &deny_entry->addr))
 	{
 	  OLSR_PRINTF(1, "Validation of address %s failed!\n",
-		      olsr_ip_to_string(adr))
+		      olsr_ip_to_string(adr));
 	  return OLSR_FALSE;
 	}
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/net_olsr.h olsrd-current/src/net_olsr.h
--- olsrd-0.5.0/src/net_olsr.h	2007-02-10 20:59:51.000000000 +0100
+++ olsrd-current/src/net_olsr.h	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: net_olsr.h,v 1.7 2007/02/10 19:59:51 bernd67 Exp $
+ * $Id: net_olsr.h,v 1.9 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 
@@ -64,7 +64,7 @@
 net_remove_buffer(struct interface *);
 
 int
-net_outbuffer_bytes_left(struct interface *);
+net_outbuffer_bytes_left(const struct interface *);
 
 olsr_u16_t
 net_output_pending(struct interface *);
@@ -73,13 +73,13 @@
 net_reserve_bufspace(struct interface *, int);
 
 int
-net_outbuffer_push(struct interface *, olsr_u8_t *, olsr_u16_t);
+net_outbuffer_push(struct interface *, const void *, const olsr_u16_t);
 
 int
-net_outbuffer_push_reserved(struct interface *, olsr_u8_t *, olsr_u16_t);
+net_outbuffer_push_reserved(struct interface *, const void *, const olsr_u16_t);
 
 int
-net_output(struct interface*);
+net_output(struct interface *);
 
 int
 net_sendroute(struct rt_entry *, struct sockaddr *);
@@ -93,14 +93,14 @@
 char *
 sockaddr_to_string(struct sockaddr *);
 
-char *
-ip_to_string(olsr_u32_t *);
+const char *
+ip_to_string(const olsr_u32_t *);
 
-char *
-ip6_to_string(struct in6_addr *);
+const char *
+ip6_to_string(const struct in6_addr *);
 
-char *
-olsr_ip_to_string(union olsr_ip_addr *);
+const char *
+olsr_ip_to_string(const union olsr_ip_addr *);
 
 int
 add_ptf(packet_transform_function);
